/*
 * Copyright (c) 2019-2020 5zig Reborn
 *
 * This file is part of The 5zig Mod
 * The 5zig Mod is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The 5zig Mod is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with The 5zig Mod.  If not, see <http://www.gnu.org/licenses/>.
 */

var MethodInsnNode = Java.type('org.objectweb.asm.tree.MethodInsnNode');
var opcodes = Java.type('org.objectweb.asm.Opcodes');

function initializeCoreMod() {
    print("Initializing Coremod");
    return {
        'loader': {
            'target': {
                'type': 'CLASS',
                'name': 'net.minecraft.client.Minecraft'
            },
            'transformer': function(classNode) {
                print("Transforming ", classNode.name);

                classNode.methods.forEach(function(m) {

                    if(m.name === '<init>') {
                        print(m.instructions)
                        m.instructions.insert(new MethodInsnNode(opcodes.INVOKESTATIC, "eu/the5zig/mod/LaunchService",
                            "load5zig", "()V", false))
                    }

                })
                return classNode
            }
        }
    }
}